## cvc5 1.3.2

=== CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Aina Niemetz, Mathias Preiner, Gereon Kremer
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

cmake_minimum_required(VERSION 3.16)

#-----------------------------------------------------------------------------#
# Project configuration

project(cvc5)

include(CheckIPOSupported)
include(GNUInstallDirs)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(version)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
if (WASM STREQUAL "OFF")
  set(CMAKE_C_EXTENSIONS OFF)
else()
  set(CMAKE_C_EXTENSIONS ON)
endif()
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# Generate compile_commands.json, which can be used for various code completion
# plugins.
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Default component used in install() commands
set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME cvc5)

#-----------------------------------------------------------------------------#
# Policies

# Required for FindGLPK since it sets CMAKE_REQUIRED_LIBRARIES
if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()

if(POLICY CMP0135)
  # For `ExternalProject_Add()`, set the timestamp of the files extracted from
  # the downloaded archive to the time of the extraction. This behavior was
  # introduced in CMake 3.23 and is the recommended to make sure that
  # dependencies get rebuilt when the URL changes.
  cmake_policy(SET CMP0135 NEW)
endif()

if(POLICY CMP0079)
  # Allows target_link_libraries() to use targets from other directories.
  # This will prevent issues with INTERFACE_LINK_LIBRARIES, which allows
  # cvc5 to be properly linked as a static library on other CMake projects.
  cmake_policy(SET CMP0079 NEW)
endif()

#-----------------------------------------------------------------------------#
# Tell CMake where to find our dependencies

if(GLPK_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${GLPK_DIR}")
endif()

# By default the contrib/get-* scripts install dependencies to deps/install.
list(APPEND CMAKE_PREFIX_PATH "${PROJECT_SOURCE_DIR}/deps/install")

#-----------------------------------------------------------------------------#

include(Helpers)

#-----------------------------------------------------------------------------#
# User options

# License
option(ENABLE_GPL "Enable GPL dependencies")

# General build options
#
# >> 3-valued: IGNORE ON OFF
#    > allows to detect if set by user (default: IGNORE)
#    > only necessary for options set for build types
option(BUILD_SHARED_LIBS          "Build shared libraries and binary")
cvc5_option(ENABLE_ASAN           "Enable ASAN build")
cvc5_option(ENABLE_UBSAN          "Enable UBSan build")
cvc5_option(ENABLE_TSAN           "Enable TSan build")
cvc5_option(ENABLE_ASSERTIONS     "Enable assertions")
cvc5_option(ENABLE_DEBUG_SYMBOLS  "Enable debug symbols")
cvc5_option(ENABLE_MUZZLE         "Suppress ALL non-result output")
cvc5_option(ENABLE_SAFE_MODE      "Enable safe mode")
cvc5_option(ENABLE_STABLE_MODE    "Enable stable mode")
cvc5_option(ENABLE_STATISTICS     "Enable statistics")
cvc5_option(ENABLE_TRACING        "Enable tracing")
cvc5_option(ENABLE_UNIT_TESTING   "Enable unit testing")
cvc5_option(ENABLE_VALGRIND       "Enable valgrind instrumentation")
cvc5_option(ENABLE_AUTO_DOWNLOAD  "Enable automatic download of dependencies")
cvc5_option(USE_PYTHON_VENV       "Install Python dependencies in virtual environment")
cvc5_option(ENABLE_IPO            "Enable interprocedural optimization")

cvc5_set_option(USE_PYTHON_VENV ON)

# >> 2-valued: ON OFF
#    > for options where we don't need to detect if set by user (default: OFF)
option(ENABLE_COVERAGE         "Enable support for gcov coverage testing")
option(ENABLE_DEBUG_CONTEXT_MM "Enable the debug context memory manager")
option(ENABLE_PROFILING        "Enable support for gprof profiling")

option(TREAT_WARNING_AS_ERROR  "Treat warnings on building as errors")

# Optional dependencies
#
# >> 2-valued: ON OFF
#    > for options where we don't need to detect if set by user (default: OFF)
option(USE_CLN           "Use CLN instead of GMP")
option(USE_COCOA         "Use CoCoALib for further polynomial operations")
option(USE_CRYPTOMINISAT "Use CryptoMiniSat SAT solver")
option(USE_EDITLINE      "Use Editline for better interactive support")
option(USE_GLPK          "Use GLPK simplex solver")
option(USE_KISSAT        "Use Kissat SAT solver")
option(USE_POLY          "Use LibPoly for polynomial arithmetic")

# Custom install directories for dependencies
# If no directory is provided by the user, we first check if the dependency was
# installed via the corresponding contrib/get-* script and if not found, we
# check the intalled system version. If the user provides a directory we
# immediately fail if the dependency was not found at the specified location.
set(GLPK_DIR          "" CACHE STRING "Set GLPK install directory")
set(PYTHONIC_PATH     "" CACHE STRING "Set Pythonic API repository path")

# Prepend binaries with prefix on make install
set(PROGRAM_PREFIX    "" CACHE STRING "Program prefix on make install")

# Supported language bindings based on new C++ API
option(BUILD_BINDINGS_PYTHON "Build Python bindings based on new C++ API ")
option(ONLY_PYTHON_EXT_SRC "Create only Python bindings source files")
option(BUILD_BINDINGS_JAVA "Build Java bindings based on new C++ API ")

# Api documentation
option(BUILD_DOCS "Build Api documentation")
option(BUILD_DOCS_GA "Build API documentation with Google Analytics")

option(BUILD_GMP "Build GMP from source")
option(BUILD_CLN "Build CLN from source")

# Link against static system libraries
cvc5_option(STATIC_BINARY "Link against static system libraries \
(enabled by default for static builds)")

option(SKIP_COMPRESS_DEBUG "Skip compression of debug symbols")
option(SKIP_SET_RPATH      "Skip setting of rpath")
option(USE_DEFAULT_LINKER  "Use default linker")

# Custom flags for WebAssembly compilation
set(WASM_FLAGS "" CACHE STRING "Link flags for the WebAssembly binary generation")
set(WASM "OFF" CACHE STRING "Use a specific extension for WebAssembly compilation")

# Make sure no other available value will be assigned to this variable
if(NOT(WASM STREQUAL "WASM" OR WASM STREQUAL "JS" OR WASM STREQUAL "HTML" OR WASM STREQUAL "OFF"))
  message(FATAL_ERROR "${WASM} is not a valid wasm flag value.")
endif()

if(WASM STREQUAL "OFF")
  set(WASM_FLAGS "")
  set(CONFIGURE_CMD_WRAPPER "")
# If it's a wasm compilation, but isn't using the right flags
elseif(BUILD_SHARED_LIBS OR NOT(STATIC_BINARY) OR NOT(ENABLE_AUTO_DOWNLOAD))
  message(FATAL_ERROR "Use --static, --static-binary and --auto-download flags for WebAssembly compilation. GMP will not compile with shared libraries.")
else()
  set(CONFIGURE_CMD_WRAPPER emconfigure)
  set(TOOLCHAIN_PREFIX wasm64-unknown-emscripten)
  string(TOLOWER ".${WASM}" WASM_EXTENSION)
  set(CMAKE_EXECUTABLE_SUFFIX ${WASM_EXTENSION})
  string(APPEND CMAKE_EXE_LINKER_FLAGS " ${WASM_FLAGS}")
endif()

#-----------------------------------------------------------------------------#
# Internal cmake variables

set(OPTIMIZATION_LEVEL 3)
set(GPL_LIBS "")

#-----------------------------------------------------------------------------#
# Determine number of threads available, used to configure (default) parallel
# execution of custom test targets (can be overriden with ARGS=-jN).

include(ProcessorCount)
ProcessorCount(CTEST_NTHREADS)
if(CTEST_NTHREADS EQUAL 0)
  set(CTEST_NTHREADS 1)
endif()

#-----------------------------------------------------------------------------#
# Build types

# Note: Module CodeCoverage requires the name of the debug build to conform
#       to cmake standards (first letter uppercase).
set(BUILD_TYPES Production Debug Testing Competition)

if(ENABLE_ASAN OR ENABLE_UBSAN OR ENABLE_TSAN)
  set(CMAKE_BUILD_TYPE Debug)
endif()

# Set the default build type to Production
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      Production CACHE STRING "Options are: ${BUILD_TYPES}" FORCE)
  # Provide drop down menu options in cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${BUILD_TYPES})
endif()

# Check if specified build type is valid.
list(FIND BUILD_TYPES ${CMAKE_BUILD_TYPE} FOUND_BUILD_TYPE)
if(${FOUND_BUILD_TYPE} EQUAL -1)
  message(FATAL_ERROR
    "'${CMAKE_BUILD_TYPE}' is not a valid build type. "
    "Available builds are: ${BUILD_TYPES}")
endif()

message(STATUS "Building ${CMAKE_BUILD_TYPE} build")
include(Config${CMAKE_BUILD_TYPE})

#-----------------------------------------------------------------------------#
# Compiler flags

add_check_c_cxx_flag("-O${OPTIMIZATION_LEVEL}")
add_check_c_cxx_flag("-Wall")
add_check_c_cxx_supression_flag("-Wno-unused-private-field")
add_check_c_cxx_supression_flag("-Wno-dangling-reference")
add_check_c_flag("-fexceptions")
add_check_cxx_flag("-Wsuggest-override")
add_check_cxx_flag("-Wnon-virtual-dtor")
add_check_c_cxx_flag("-Wimplicit-fallthrough")
add_check_c_cxx_flag("-Wshadow")
add_check_c_cxx_flag("-fno-operator-names")

# Assume no dynamic initialization of thread-local variables in non-defining
# translation units. This option should result in better performance and works
# around crashing issues with our Windows build.
add_check_cxx_flag("-fno-extern-tls-init")

# Disable -Wclass-memaccess to suppress 'no trivial copy-assignment' in MiniSat
# code.
add_check_cxx_supression_flag("-Wno-class-memaccess")

if (WIN32)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--stack,100000000")
endif ()

# Keep the default linker on MSYS, as switching it prevents the build system from
# using the GMP system library if available. For Linux ARM64, the default linker is
# also required due to a bug in the gold linker specific to ARM64 architectures.
if (NOT ("${CMAKE_GENERATOR}" STREQUAL "MSYS Makefiles") AND
    NOT CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64" AND
    NOT USE_DEFAULT_LINKER)
  #-----------------------------------------------------------------------------#
  # Use ld.mold if available, otherwise use ld.gold if available

  set(USE_EXPLICIT_LINKER_FLAG FALSE)
  execute_process(COMMAND ${CMAKE_C_COMPILER}
                  -fuse-ld=mold
                  -Wl,--version ERROR_QUIET OUTPUT_VARIABLE LD_MOLD_VERSION)
  if ("${LD_MOLD_VERSION}" MATCHES "mold")
    set(USE_EXPLICIT_LINKER_FLAG TRUE)
    set(EXPLICIT_LINKER_FLAG " -fuse-ld=mold")
    message(STATUS "Using mold linker.")
  else ()
    execute_process(COMMAND ${CMAKE_C_COMPILER}
                    -fuse-ld=gold
                    -Wl,--version ERROR_QUIET OUTPUT_VARIABLE LD_GOLD_VERSION)
    if ("${LD_GOLD_VERSION}" MATCHES "GNU gold")
      set(USE_EXPLICIT_LINKER_FLAG TRUE)
      set(EXPLICIT_LINKER_FLAG " -fuse-ld=gold")
      message(STATUS "Using GNU gold linker.")
    endif ()
  endif ()
  if (USE_EXPLICIT_LINKER_FLAG)
    string(APPEND CMAKE_EXE_LINKER_FLAGS ${EXPLICIT_LINKER_FLAG})
    string(APPEND CMAKE_SHARED_LINKER_FLAGS ${EXPLICIT_LINKER_FLAG})
    string(APPEND CMAKE_MODULE_LINKER_FLAGS ${EXPLICIT_LINKER_FLAG})
  endif ()
endif()

#-----------------------------------------------------------------------------#
# Use interprocedural optimization if requested

if(ENABLE_IPO)
  check_ipo_supported(RESULT have_ipo_support)
  if(have_ipo_support)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
  else()
    message(STATUS "Interprocedural optimization not supported.")
    set(ENABLE_IPO OFF)
  endif()
endif()

=== docs/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Gereon Kremer, Aina Niemetz, Mathias Preiner
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##
find_package(Sphinx REQUIRED)
check_python_module(breathe)
check_python_module(sphinxcontrib.bibtex sphinxcontrib-bibtex)
check_python_module(sphinx_tabs.tabs sphinx-tabs)
check_python_module(sphinxcontrib.programoutput sphinxcontrib-programoutput)
check_python_module(sphinx_rtd_theme sphinx-rtd-theme)

add_subdirectory(api)

set(SPHINX_INPUT_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SPHINX_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/sphinx)
if(BUILD_DOCS_GA)
  check_python_module(sphinxcontrib.googleanalytics sphinxcontrib-googleanalytics)
  set(GOOGLE_ANALYTICS_ENABLE "True")
else()
  set(GOOGLE_ANALYTICS_ENABLE "False")
endif()

configure_file(conf.py.in ${CMAKE_CURRENT_BINARY_DIR}/conf.py)
configure_file(references.bib ${CMAKE_CURRENT_BINARY_DIR}/references.bib COPYONLY)

set(SPHINX_WARNING_AS_ERROR "")
if(TREAT_WARNING_AS_ERROR)
  set(SPHINX_WARNING_AS_ERROR "-W")
endif()

add_custom_target(
  docs
  DEPENDS docs-cpp docs-c docs-java docs-python gen-options cvc5-bin
  COMMAND
    ${Sphinx_EXECUTABLE} -v ${SPHINX_WARNING_AS_ERROR} -b html -c ${CMAKE_CURRENT_BINARY_DIR}
    # Tell Breathe where to find the Doxygen output
    -Dbreathe_projects.cvc5=${CPP_DOXYGEN_XML_DIR}
    -Dbreathe_projects.cvc5_c=${C_DOXYGEN_XML_DIR}
    -Dbreathe_projects.std=${CPP_DOXYGEN_XML_DIR} ${SPHINX_INPUT_DIR}
    ${SPHINX_OUTPUT_DIR}
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating Sphinx Api docs"
)

add_custom_command(
  TARGET docs
  POST_BUILD
  COMMAND
    ${CMAKE_COMMAND} -E cmake_echo_color --cyan "Preview docs in browser: file://localhost${SPHINX_OUTPUT_DIR}/index.html"
)

set(SPHINX_GH_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/sphinx-gh)
add_custom_target(
  docs-gh
  DEPENDS docs
  # remove existing sphinx-gh/ directory
  COMMAND ${CMAKE_COMMAND} -E remove_directory ${SPHINX_GH_OUTPUT_DIR}
  # copy sphinx/ to sphinx-gh/
  COMMAND ${CMAKE_COMMAND} -E copy_directory ${SPHINX_OUTPUT_DIR}
          ${SPHINX_GH_OUTPUT_DIR}
  # remove leftovers from the build
  COMMAND ${CMAKE_COMMAND} -E remove_directory ${SPHINX_GH_OUTPUT_DIR}/.doctrees
          ${SPHINX_GH_OUTPUT_DIR}/_sources ${SPHINX_GH_OUTPUT_DIR}/_static/fonts
  COMMAND ${CMAKE_COMMAND} -E remove ${SPHINX_GH_OUTPUT_DIR}/objects.inv
  # rename _static/ to static/ (as jekyll ignores _*/ dirs)
  COMMAND ${CMAKE_COMMAND} -E rename ${SPHINX_GH_OUTPUT_DIR}/_static
          ${SPHINX_GH_OUTPUT_DIR}/static
  COMMAND find ${SPHINX_GH_OUTPUT_DIR} -type f | xargs sed -i'orig'
          's/_static/static/'
  COMMAND find ${SPHINX_GH_OUTPUT_DIR} -name '*orig' -delete
  # done
  COMMENT "Generating GitHub Api docs"
)

=== examples/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Aina Niemetz, Mathias Preiner, Mudathir Mohamed
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

cmake_minimum_required(VERSION 3.16)

project(cvc5-examples)

set(CMAKE_CXX_STANDARD 17)

enable_testing()

# Find cvc5 package. If cvc5 is not installed into the default system location
# use `cmake .. -DCMAKE_PREFIX_PATH=path/to/lib/cmake` to specify the location
# of cvc5Config.cmake.
find_package(cvc5)

set(EXAMPLES_BIN_DIR ${CMAKE_BINARY_DIR}/bin)

# Add example target and create test to run example with ctest.
#
# > name: The name of the example
# > src_files: The list of source files passed as string "src1 src2 ..."
#              (alternative: "src1;src2;...").  If empty, <name>.cpp is assumed.
# > output_dir: Determines the examples subdirectory and is empty (passed as
#               empty string) for the examples root directory (this)
# > ARGN: Any additional arguments passed to the macro are interpreted as
#         as arguments to the test executable.
macro(cvc5_add_example name src_files output_dir)
  # The build target is created without the path prefix (not supported),
  # e.g., for '<output_dir>/myexample.cpp'
  #   we create build target 'myexample'
  #   and build it with 'make myexample'.
  # As a consequence, all build target names must be globally unique.
  if("${src_files}" STREQUAL "")
    set(src_files_list ${name}.cpp)
  else()
    string(REPLACE " " ";" src_files_list "${src_files}")
  endif()

  add_executable(${name} ${src_files_list})
  target_link_libraries(${name} cvc5::cvc5 cvc5::cvc5parser)

  # The test target is prefixed with the path,
  # e.g., for '<output_dir>/myexample.cpp'
  #   we create test target '<output_dir>/myexample'
  #   and run it with 'ctest -R "<output_dir>/myexample"'.
  set(example_bin_dir ${EXAMPLES_BIN_DIR}/${output_dir})
  if("${output_dir}" STREQUAL "")
    set(example_test ${name})
  else()
    set(example_test ${output_dir}/${name})
  endif()
  set_target_properties(${name}
    PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${example_bin_dir})
  add_test(${example_test} ${example_bin_dir}/${name} ${ARGN})
endmacro()

cvc5_add_example(simple_vc_cxx "" "")
cvc5_add_example(simple_vc_quant_cxx "" "")

add_subdirectory(api/cpp)
add_subdirectory(api/c)

if(TARGET cvc5::cvc5jar)
  find_package(Java REQUIRED)
  include(UseJava)

  # get directory build/install/lib where libcvc5jni.so is installed
  get_target_property(CVC5_LIB_FILE cvc5::cvc5 LOCATION)
  get_filename_component(CVC5_JNI_PATH ${CVC5_LIB_FILE} DIRECTORY)
  message(STATUS "CVC5_JNI_PATH: ${CVC5_JNI_PATH}")


  get_target_property(CVC5_JAR cvc5::cvc5jar JAR_FILE)
  message(STATUS "cvc5jar: ${CVC5_JAR}")

  if(WIN32)
    set(PATH_SEP ";")
  else()
    set(PATH_SEP ":")
  endif()

  add_jar(SimpleVC SimpleVC.java INCLUDE_JARS "${CVC5_JAR}")
  add_test(
    NAME java/SimpleVC
    COMMAND
      ${Java_JAVA_EXECUTABLE}
        -cp "${CVC5_JAR}${PATH_SEP}${CMAKE_BINARY_DIR}/SimpleVC.jar"
        -Djava.library.path=${CVC5_JNI_PATH}
        SimpleVC
  )
  add_subdirectory(api/java)
endif()

if(CVC5_BINDINGS_PYTHON)
  message(STATUS "with Python examples")
  # If legacy Python API has been built
  add_subdirectory(api/python)
endif()

=== src/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Andrew Reynolds, Mathias Preiner, Gereon Kremer
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

# Collect libcvc5 source files
libcvc5_add_sources(
  api/c/cvc5.cpp
  api/c/cvc5_c_structs.h
  api/c/cvc5_c_structs.cpp
  api/c/cvc5_checks.h
  api/cpp/cvc5.cpp
  api/cpp/cvc5_checks.h
  api/cpp/cvc5_types.cpp
  api/cpp/cvc5_skolem_id.cpp
  decision/assertion_list.cpp
  decision/assertion_list.h
  decision/decision_engine.cpp
  decision/decision_engine.h
  decision/justification_strategy.cpp
  decision/justification_strategy.h
  decision/justify_cache.cpp
  decision/justify_cache.h
  decision/justify_info.cpp
  decision/justify_info.h
  decision/justify_stack.cpp
  decision/justify_stack.h
  decision/justify_stats.cpp
  decision/justify_stats.h
  lib/clock_gettime.c
  lib/clock_gettime.h
  lib/ffs.c
  lib/ffs.h
  lib/replacements.h
  lib/strtok_r.c
  lib/strtok_r.h
  options/language.cpp
  options/language.h
  options/managed_streams.cpp
  options/managed_streams.h
  options/option_exception.cpp
  options/option_exception.h
  options/options_handler.cpp
  options/options_handler.h
  options/options_listener.h
  options/options_public.h
  preprocessing/assertion_pipeline.cpp
  preprocessing/assertion_pipeline.h
  preprocessing/learned_literal_manager.cpp
  preprocessing/learned_literal_manager.h
  preprocessing/passes/ackermann.cpp
  preprocessing/passes/ackermann.h
  preprocessing/passes/apply_substs.cpp
  preprocessing/passes/apply_substs.h
  preprocessing/passes/bool_to_bv.cpp
  preprocessing/passes/bool_to_bv.h
  preprocessing/passes/bv_eager_atoms.cpp
  preprocessing/passes/bv_eager_atoms.h
  preprocessing/passes/bv_gauss.cpp
  preprocessing/passes/bv_gauss.h
  preprocessing/passes/bv_intro_pow2.cpp
  preprocessing/passes/bv_intro_pow2.h
  preprocessing/passes/bv_to_bool.cpp
  preprocessing/passes/bv_to_bool.h
  preprocessing/passes/bv_to_int.cpp
  preprocessing/passes/bv_to_int.h
  preprocessing/passes/extended_rewriter_pass.cpp
  preprocessing/passes/extended_rewriter_pass.h
  preprocessing/passes/ff_bitsum.cpp
  preprocessing/passes/ff_bitsum.h
  preprocessing/passes/ff_disjunctive_bit.cpp
  preprocessing/passes/ff_disjunctive_bit.h
  preprocessing/passes/foreign_theory_rewrite.cpp
  preprocessing/passes/foreign_theory_rewrite.h
  preprocessing/passes/fun_def_fmf.cpp
  preprocessing/passes/fun_def_fmf.h
  preprocessing/passes/global_negate.cpp
  preprocessing/passes/global_negate.h
  preprocessing/passes/ho_elim.cpp
  preprocessing/passes/ho_elim.h
  preprocessing/passes/int_to_bv.cpp
  preprocessing/passes/int_to_bv.h
  preprocessing/passes/ite_removal.cpp
  preprocessing/passes/ite_removal.h
  preprocessing/passes/ite_simp.cpp
  preprocessing/passes/ite_simp.h
  preprocessing/passes/learned_rewrite.cpp
  preprocessing/passes/learned_rewrite.h
  preprocessing/passes/miplib_trick.cpp
  preprocessing/passes/miplib_trick.h
  preprocessing/passes/nl_ext_purify.cpp
  preprocessing/passes/nl_ext_purify.h
  preprocessing/passes/non_clausal_simp.cpp
  preprocessing/passes/non_clausal_simp.h
  preprocessing/passes/pseudo_boolean_processor.cpp
  preprocessing/passes/pseudo_boolean_processor.h
  preprocessing/passes/quantifiers_preprocess.cpp
  preprocessing/passes/quantifiers_preprocess.h
  preprocessing/passes/real_to_int.cpp
  preprocessing/passes/real_to_int.h
  preprocessing/passes/rewrite.cpp
  preprocessing/passes/rewrite.h
  preprocessing/passes/sep_skolem_emp.cpp
  preprocessing/passes/sep_skolem_emp.h
  preprocessing/passes/sort_infer.cpp
  preprocessing/passes/sort_infer.h
  preprocessing/passes/static_learning.cpp
  preprocessing/passes/static_learning.h
  preprocessing/passes/static_rewrite.cpp
  preprocessing/passes/static_rewrite.h
  preprocessing/passes/strings_eager_pp.cpp
  preprocessing/passes/strings_eager_pp.h
  preprocessing/passes/sygus_inference.cpp
  preprocessing/passes/sygus_inference.h
  preprocessing/passes/synth_rew_rules.cpp
  preprocessing/passes/synth_rew_rules.h
  preprocessing/passes/theory_preprocess.cpp
  preprocessing/passes/theory_preprocess.h
  preprocessing/passes/unconstrained_simplifier.cpp
  preprocessing/passes/unconstrained_simplifier.h
  preprocessing/passes/normalize.cpp
  preprocessing/passes/normalize.h
  preprocessing/preprocessing_pass.cpp
  preprocessing/preprocessing_pass.h
  preprocessing/preprocessing_pass_context.cpp
  preprocessing/preprocessing_pass_context.h
  preprocessing/preprocessing_pass_registry.cpp
  preprocessing/preprocessing_pass_registry.h
  preprocessing/util/boolean_simplification.cpp
  preprocessing/util/boolean_simplification.h
  preprocessing/util/ite_utilities.cpp
  preprocessing/util/ite_utilities.h
  printer/ast/ast_printer.cpp
  printer/ast/ast_printer.h
  printer/enum_to_string.cpp
  printer/enum_to_string.h
  printer/let_binding.cpp
  printer/let_binding.h
  printer/printer.cpp
  printer/printer.h
  printer/smt2/smt2_printer.cpp
  printer/smt2/smt2_printer.h
  proof/alf/alf_dependent_type_converter.cpp
  proof/alf/alf_dependent_type_converter.h
  proof/alf/alf_list_node_converter.cpp
  proof/alf/alf_list_node_converter.h
  proof/alf/alf_node_converter.cpp
  proof/alf/alf_node_converter.h
  proof/alf/alf_print_channel.cpp
  proof/alf/alf_print_channel.h
  proof/alf/alf_printer.cpp
  proof/alf/alf_printer.h
  proof/assumption_proof_generator.cpp
  proof/assumption_proof_generator.h
  proof/buffered_proof_generator.cpp
  proof/buffered_proof_generator.h
  proof/conv_proof_generator.cpp
  proof/conv_proof_generator.h
  proof/conv_seq_proof_generator.cpp
  proof/conv_seq_proof_generator.h
  proof/clause_id.h
  proof/dot/dot_printer.cpp
  proof/dot/dot_printer.h
  proof/eager_proof_generator.cpp
  proof/eager_proof_generator.h
  proof/lazy_proof.cpp
  proof/lazy_proof.h
  proof/lazy_proof_chain.cpp
  proof/lazy_proof_chain.h
  proof/lazy_tree_proof_generator.cpp
  proof/lazy_tree_proof_generator.h
  proof/lfsc/lfsc_list_sc_node_converter.cpp
  proof/lfsc/lfsc_list_sc_node_converter.h
  proof/lfsc/lfsc_node_converter.cpp
  proof/lfsc/lfsc_node_converter.h
  proof/lfsc/lfsc_post_processor.cpp
  proof/lfsc/lfsc_post_processor.h
  proof/lfsc/lfsc_printer.cpp
  proof/lfsc/lfsc_printer.h
  proof/lfsc/lfsc_print_channel.cpp
  proof/lfsc/lfsc_print_channel.h
  proof/lfsc/lfsc_util.cpp
  proof/lfsc/lfsc_util.h
  proof/method_id.cpp
  proof/method_id.h
  proof/print_expr.cpp
  proof/print_expr.h
  proof/proof.cpp
  proof/proof.h
  proof/proof_checker.cpp
  proof/proof_checker.h
  proof/proof_ensure_closed.cpp
  proof/proof_ensure_closed.h
  proof/proof_generator.cpp
  proof/proof_generator.h
  proof/proof_letify.cpp
  proof/proof_letify.h
  proof/proof_node.cpp
  proof/proof_node.h
  proof/proof_node_algorithm.cpp
  proof/proof_node_algorithm.h
  proof/proof_node_converter.cpp
  proof/proof_node_converter.h
  proof/proof_node_to_sexpr.cpp
  proof/proof_node_to_sexpr.h
  proof/proof_node_manager.cpp
  proof/proof_node_manager.h
  proof/proof_node_updater.cpp
  proof/proof_node_updater.h
  proof/proof_rule_checker.cpp
  proof/proof_rule_checker.h
  proof/proof_set.h
  proof/proof_step_buffer.cpp
  proof/proof_step_buffer.h
  proof/resolution_proofs_util.cpp
  proof/resolution_proofs_util.h
  proof/rewrite_proof_generator.cpp
  proof/rewrite_proof_generator.h
  proof/subtype_elim_proof_converter.cpp
  proof/subtype_elim_proof_converter.h
  proof/trust_id.cpp
  proof/trust_id.h
  proof/trust_node.cpp
  proof/trust_node.h
  proof/trust_proof_generator.cpp
  proof/trust_proof_generator.h
  proof/theory_proof_step_buffer.cpp
  proof/theory_proof_step_buffer.h
  proof/unsat_core.cpp
  proof/unsat_core.h
  proof/valid_witness_proof_generator.cpp
  proof/valid_witness_proof_generator.h
  proof/alethe/alethe_let_binding.cpp
  proof/alethe/alethe_let_binding.h
  proof/alethe/alethe_node_converter.cpp
  proof/alethe/alethe_node_converter.h
  proof/alethe/alethe_post_processor.cpp
  proof/alethe/alethe_post_processor.h
  proof/alethe/alethe_printer.h
  proof/alethe/alethe_printer.cpp
  proof/alethe/alethe_proof_rule.cpp
  proof/alethe/alethe_proof_rule.h
  prop/cadical/cadical.cpp
  prop/cadical/cadical.h
  prop/cadical/cdclt_propagator.cpp
  prop/cadical/cdclt_propagator.h
  prop/cadical/proof_tracer.cpp
  prop/cadical/proof_tracer.h
  prop/cadical/util.cpp
  prop/cadical/util.h
  prop/cnf_stream.cpp
  prop/cnf_stream.h
  prop/cryptominisat.cpp
  prop/cryptominisat.h
  prop/kissat.cpp
  prop/kissat.h
  prop/learned_db.cpp
  prop/learned_db.h
  prop/lemma_inprocess.cpp
  prop/lemma_inprocess.h
  prop/minisat/core/Dimacs.h
  prop/minisat/core/Solver.cc
  prop/minisat/core/Solver.h
  prop/minisat/core/SolverTypes.h
  prop/minisat/minisat.cpp
  prop/minisat/minisat.h
  prop/minisat/mtl/Alg.h
  prop/minisat/mtl/Alloc.h
  prop/minisat/mtl/Heap.h
  prop/minisat/mtl/IntTypes.h
  prop/minisat/mtl/Map.h
  prop/minisat/mtl/Queue.h
  prop/minisat/mtl/Sort.h
  prop/minisat/mtl/Vec.h
  prop/minisat/mtl/XAlloc.h
  prop/minisat/opt_clauses_manager.cpp
  prop/minisat/opt_clauses_manager.h
  prop/minisat/sat_proof_manager.cpp
  prop/minisat/sat_proof_manager.h
  prop/minisat/simp/SimpSolver.cc
  prop/minisat/simp/SimpSolver.h
  prop/minisat/utils/Options.h
  prop/proof_cnf_stream.cpp
  prop/proof_cnf_stream.h
  prop/proof_post_processor.cpp
  prop/proof_post_processor.h
  prop/prop_engine.cpp
  prop/prop_engine.h
  prop/prop_proof_manager.cpp
  prop/prop_proof_manager.h
  prop/registrar.h
  prop/sat_solver.h
  prop/sat_solver_factory.cpp
  prop/sat_solver_factory.h
  prop/sat_solver_types.cpp
  prop/sat_solver_types.h
  prop/skolem_def_manager.cpp
  prop/skolem_def_manager.h
  prop/theory_preregistrar.cpp
  prop/theory_preregistrar.h
  prop/theory_proxy.cpp
  prop/theory_proxy.h
  prop/zero_level_learner.cpp
  prop/zero_level_learner.h
  smt/abduction_solver.cpp
  smt/abduction_solver.h
  smt/assertions.cpp
  smt/assertions.h
  smt/check_models.cpp
  smt/check_models.h
  smt/context_manager.cpp
  smt/context_manager.h
  smt/difficulty_post_processor.cpp
  smt/difficulty_post_processor.h
  smt/env.cpp
  smt/env.h
  smt/env_obj.cpp
  smt/env_obj.h
  smt/expand_definitions.cpp
  smt/expand_definitions.h
  smt/find_synth_solver.cpp
  smt/find_synth_solver.h
  smt/listeners.cpp
  smt/listeners.h
  smt/logic_exception.h
  smt/illegal_checker.cpp
  smt/illegal_checker.h
  smt/interpolation_solver.cpp
  smt/interpolation_solver.h
  smt/model.cpp
  smt/model.h
  smt/model_core_builder.cpp
  smt/model_core_builder.h
  smt/model_blocker.cpp
  smt/model_blocker.h
  smt/quant_elim_solver.cpp
  smt/quant_elim_solver.h
  smt/preprocessor.cpp
  smt/preprocessor.h
  smt/preprocess_proof_generator.cpp
  smt/preprocess_proof_generator.h
  smt/print_benchmark.cpp
  smt/print_benchmark.h
  smt/process_assertions.cpp
  smt/process_assertions.h
  smt/proof_manager.cpp
  smt/proof_manager.h
  smt/proof_final_callback.cpp
  smt/proof_final_callback.h
  smt/proof_logger.cpp
  smt/proof_logger.h
  smt/proof_post_processor.cpp
  smt/proof_post_processor.h
  smt/proof_post_processor_dsl.cpp
  smt/proof_post_processor_dsl.h
  smt/set_defaults.cpp
  smt/set_defaults.h
  smt/solver_engine.cpp
  smt/solver_engine.h
  smt/solver_engine_state.cpp
  smt/solver_engine_state.h
  smt/solver_engine_stats.cpp
  smt/solver_engine_stats.h
  smt/smt_driver.cpp
  smt/smt_driver.h
  smt/smt_driver_deep_restarts.cpp
  smt/smt_driver_deep_restarts.h
  smt/smt_mode.cpp
  smt/smt_mode.h
  smt/smt_solver.cpp
  smt/smt_solver.h
  smt/sygus_solver.cpp
  smt/sygus_solver.h
  smt/term_formula_removal.cpp

=== test/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Daniel Larraz, Mathias Preiner, Aina Niemetz
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

# Add target 'check', builds and runs
# > unit tests
# > regression tests of levels 0 and 1
# > api tests

set(ENV_PATH_CMD )
if(WIN32)
  # Set up a command to add DLL library paths to PATH
  set(ENV_PATH )
  list(APPEND ENV_PATH ${CMAKE_BINARY_DIR}\\src)
  list(APPEND ENV_PATH ${CMAKE_BINARY_DIR}\\src\\parser)
  list(APPEND ENV_PATH ${DEPS_BASE}\\bin)
  list(APPEND ENV_PATH $ENV{PATH})
  # Escape semicolons and backslashes
  string(REPLACE "\\" "\\\\" ENV_PATH "${ENV_PATH}")
  list(JOIN ENV_PATH "\;" ENV_PATH)
  set(ENV_PATH_CMD ${CMAKE_COMMAND} -E env "PATH=${ENV_PATH}")
endif()

add_custom_target(build-tests)

# Note: Do not add custom targets for running tests (regress, apitests,
# units) as dependencies to other run targets. This will result in executing
# tests multiple times. For example, if check would depend on regress it would
# first run the command of the regress target (i.e., run all regression tests)
# and afterwards run the command specified for the check target.
# Dependencies of check are added in the corresponding subdirectories.
add_custom_target(check
  COMMAND
    ctest --output-on-failure -LE "regress[3-4]" -j${CTEST_NTHREADS} $$ARGS
  DEPENDS
    build-tests)

#-----------------------------------------------------------------------------#
# Add subdirectories

add_subdirectory(regress)
add_subdirectory(api EXCLUDE_FROM_ALL)
add_subdirectory(binary EXCLUDE_FROM_ALL)
if(ENABLE_UNIT_TESTING)
  add_subdirectory(unit EXCLUDE_FROM_ALL)
endif()

=== docs/api/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Aina Niemetz, Gereon Kremer, Daniel Larraz
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
#
add_subdirectory(cpp)
add_subdirectory(c)
add_subdirectory(java)
add_subdirectory(python)

# tell parent scope where to find the output xml
set(CPP_DOXYGEN_XML_DIR
  "${CPP_DOXYGEN_XML_DIR}"
    PARENT_SCOPE
)
set(C_DOXYGEN_XML_DIR
  "${C_DOXYGEN_XML_DIR}"
    PARENT_SCOPE
)

=== src/base/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Gereon Kremer, Andrew V. Jones
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

# Generate cvc5config.h header
configure_file(cvc5config.h.in cvc5config.h)

#-----------------------------------------------------------------------------#

set(LIBBASE_SOURCES
  check.cpp
  check.h
  configuration.cpp
  configuration.h
  configuration_private.h
  exception.cpp
  exception.h
  listener.cpp
  listener.h
  modal_exception.h
  output.cpp
  output.h
  ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.cpp
)
set_source_files_properties(
  ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.cpp
  PROPERTIES GENERATED TRUE
)

#-----------------------------------------------------------------------------#
# Generate code for debug/trace tags

set(collect_tags_script ${CMAKE_CURRENT_LIST_DIR}/collect_tags.py)

file(GLOB_RECURSE source_files
     ${PROJECT_SOURCE_DIR}/src/*.cpp
     ${PROJECT_SOURCE_DIR}/src/*.cc
     ${PROJECT_SOURCE_DIR}/src/*.h
     ${PROJECT_SOURCE_DIR}/src/*.g)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
  COMMAND ${Python_EXECUTABLE} ${collect_tags_script} ${CMAKE_CURRENT_BINARY_DIR}/ ${PROJECT_SOURCE_DIR}/src
  DEPENDS ${collect_tags_script} ${source_files}
)

add_custom_target(gen-tags
  DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
)

set_source_files_properties(
  ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
  PROPERTIES GENERATED TRUE
)

add_library(cvc5base OBJECT ${LIBBASE_SOURCES})
set_target_properties(cvc5base PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(cvc5base PRIVATE -D__BUILDING_CVC5LIB -Dcvc5_obj_EXPORTS)
add_dependencies(cvc5base gen-versioninfo gen-tags)

=== src/context/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Gereon Kremer, Andres Noetzli
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

set(LIBCONTEXT_SOURCES
  cdhashmap.h
  cdhashmap_forward.h
  cdhashset.h
  cdhashset_forward.h
  cdinsert_hashmap.h
  cdinsert_hashmap_forward.h
  cdlist.h
  cdlist_forward.h
  cdmaybe.h
  cdo.h
  cdqueue.h
  cdtrail_queue.h
  context.cpp
  context.h
  context_mm.cpp
  context_mm.h
  default_clean_up.h
)

add_library(cvc5context OBJECT ${LIBCONTEXT_SOURCES})
set_target_properties(cvc5context PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(cvc5context PRIVATE -D__BUILDING_CVC5LIB -Dcvc5_obj_EXPORTS)

=== src/expr/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Andrew Reynolds, José Neto, Mathias Preiner
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

libcvc5_add_sources(
  aci_norm.cpp
  aci_norm.h
  algorithm/flatten.h
  annotation_elim_node_converter.cpp
  annotation_elim_node_converter.h
  array_store_all.cpp
  array_store_all.h
  ascription_type.cpp
  ascription_type.h
  attribute.h
  attribute.cpp
  attribute_internals.h
  attribute_unique_id.h
  bound_var_id.cpp
  bound_var_id.h
  bound_var_manager.cpp
  bound_var_manager.h
  cardinality_constraint.cpp
  cardinality_constraint.h
  codatatype_bound_variable.cpp
  codatatype_bound_variable.h
  elim_shadow_converter.cpp
  elim_shadow_converter.h
  elim_witness_converter.cpp
  elim_witness_converter.h
  emptyset.cpp
  emptyset.h
  emptybag.cpp
  emptybag.h
  free_var_cache.cpp
  free_var_cache.h
  function_array_const.cpp
  function_array_const.h
  internal_skolem_id.cpp
  internal_skolem_id.h
  kind_map.h
  match_trie.cpp
  match_trie.h
  nary_match_trie.cpp
  nary_match_trie.h
  nary_term_util.cpp
  nary_term_util.h
  node.cpp
  node.h
  node_algorithm.cpp
  node_algorithm.h
  node_builder.cpp
  node_builder.h
  node_converter.cpp
  node_converter.h
  node_manager_attributes.h
  node_self_iterator.h
  node_trie.cpp
  node_trie.h
  node_trie_algorithm.cpp
  node_trie_algorithm.h
  node_traversal.cpp
  node_traversal.h
  node_value.cpp
  node_value.h
  oracle.h
  oracle_caller.cpp
  oracle_caller.h
  plugin.cpp
  plugin.h
  sequence.cpp
  sequence.h
  node_visitor.h
  skolem_manager.cpp
  skolem_manager.h
  sort_type_size.cpp
  sort_type_size.h
  subtype_elim_node_converter.cpp
  subtype_elim_node_converter.h
  term_canonize.cpp
  term_canonize.h
  term_context.cpp
  term_context.h
  term_context_node.cpp
  term_context_node.h
  term_context_stack.cpp
  term_context_stack.h
  type_checker.h
  type_matcher.cpp
  type_matcher.h
  type_node.cpp
  type_node.h
  dtype.h
  dtype.cpp
  dtype_cons.h
  dtype_cons.cpp
  dtype_selector.h
  dtype_selector.cpp
  sequence.cpp
  sequence.h
  sort_to_term.cpp
  sort_to_term.h
  subs.cpp
  subs.h
  sygus_datatype.cpp
  sygus_datatype.h
  sygus_grammar.cpp
  sygus_grammar.h
  sygus_term_enumerator.cpp
  sygus_term_enumerator.h
  variadic_trie.cpp
  variadic_trie.h
  non_closed_node_converter.cpp
  non_closed_node_converter.h
  normalize_sort_converter.cpp
  normalize_sort_converter.h
)

libcvc5_add_sources(GENERATED
  kind.cpp
  kind.h
  metakind.cpp
  metakind.h
  node_manager.cpp
  node_manager.h
  type_checker.cpp
  type_properties.cpp
  type_properties.h
)

#
# Generate code for kinds.
#

set(mkkind_script ${CMAKE_CURRENT_LIST_DIR}/mkkind.py)
set(mkmetakind_script ${CMAKE_CURRENT_LIST_DIR}/mkmetakind.py)
set(mkexpr_script ${CMAKE_CURRENT_LIST_DIR}/mkexpr.py)

add_custom_command(
  OUTPUT kind.h
  COMMAND
    ${Python_EXECUTABLE}
    ${mkkind_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/kind_template.h
    --output ${CMAKE_CURRENT_BINARY_DIR}/kind.h
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkkind.py kind_template.h ${KINDS_TOML_FILES}
)

add_custom_command(
  OUTPUT kind.cpp
  COMMAND
    ${Python_EXECUTABLE}
    ${mkkind_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/kind_template.cpp
    --output ${CMAKE_CURRENT_BINARY_DIR}/kind.cpp
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkkind.py kind_template.cpp kind.h ${KINDS_TOML_FILES}
)

add_custom_command(
  OUTPUT type_properties.h
  COMMAND
    ${Python_EXECUTABLE}
    ${mkkind_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/type_properties_template.h
    --output ${CMAKE_CURRENT_BINARY_DIR}/type_properties.h
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkkind.py type_properties_template.h ${KINDS_TOML_FILES}
)

add_custom_command(
  OUTPUT type_properties.cpp
  COMMAND
    ${Python_EXECUTABLE}
    ${mkkind_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/type_properties_template.cpp
    --output ${CMAKE_CURRENT_BINARY_DIR}/type_properties.cpp
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkkind.py type_properties_template.cpp type_properties.h ${KINDS_TOML_FILES}
)

add_custom_command(
  OUTPUT metakind.h
  COMMAND
    ${Python_EXECUTABLE}
    ${mkmetakind_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/metakind_template.h
    --output ${CMAKE_CURRENT_BINARY_DIR}/metakind.h
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkmetakind.py metakind_template.h ${KINDS_TOML_FILES}
)

add_custom_command(
  OUTPUT metakind.cpp
  COMMAND
    ${Python_EXECUTABLE}
    ${mkmetakind_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/metakind_template.cpp
    --output ${CMAKE_CURRENT_BINARY_DIR}/metakind.cpp
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkmetakind.py metakind_template.cpp metakind.h ${KINDS_TOML_FILES}
)

add_custom_command(
  OUTPUT node_manager.h
  COMMAND
    ${Python_EXECUTABLE}
    ${mkmetakind_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/node_manager_template.h
    --output ${CMAKE_CURRENT_BINARY_DIR}/node_manager.h
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkmetakind.py node_manager_template.h ${KINDS_TOML_FILES}
)

add_custom_command(
  OUTPUT node_manager.cpp
  COMMAND
    ${Python_EXECUTABLE}
    ${mkmetakind_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/node_manager_template.cpp
    --output ${CMAKE_CURRENT_BINARY_DIR}/node_manager.cpp
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkmetakind.py node_manager_template.cpp node_manager.h ${KINDS_TOML_FILES}
)

add_custom_command(
  OUTPUT type_checker.cpp
  COMMAND
    ${Python_EXECUTABLE}
    ${mkexpr_script}
    --template ${CMAKE_CURRENT_LIST_DIR}/type_checker_template.cpp
    --output ${CMAKE_CURRENT_BINARY_DIR}/type_checker.cpp
    --kinds ${KINDS_TOML_FILES}
  DEPENDS mkexpr.py type_checker_template.cpp ${KINDS_TOML_FILES}
)

add_custom_target(gen-expr
  DEPENDS
    kind.cpp
    kind.h
    metakind.cpp
    metakind.h
    node_manager.cpp
    node_manager.h
    type_checker.cpp
    type_properties.cpp
    type_properties.h
)

=== src/main/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Gereon Kremer, Aina Niemetz
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

# libmain source files
set(libmain_src_files
  command_executor.cpp
  interactive_shell.cpp
  interactive_shell.h
  main.h
  options.h
  portfolio_driver.cpp
  portfolio_driver.h
  signal_handlers.cpp
  signal_handlers.h
  time_limit.cpp
  time_limit.h
)
set(libmain_gen_src_files
  ${CMAKE_CURRENT_BINARY_DIR}/options.cpp
)
set_source_files_properties(${libmain_gen_src_files} PROPERTIES GENERATED TRUE)

#-----------------------------------------------------------------------------#
# Build object library since we will use the object files for cvc5-bin and
# main-test library.

add_library(main OBJECT ${libmain_src_files} ${libmain_gen_src_files})
target_compile_definitions(main PRIVATE -D__BUILDING_CVC5DRIVER -Dcvc5_obj_EXPORTS)
set_target_properties(main PROPERTIES POSITION_INDEPENDENT_CODE ON)

add_dependencies(main gen-tokens cvc5-obj cvc5parser-objs)

# main-test library is only used for linking against api and unit tests so
# that we don't have to include all object files of main into each api/unit
# test. Do not link against main-test in any other case.
add_library(main-test driver_unified.cpp $<TARGET_OBJECTS:main>)
target_compile_definitions(main-test PRIVATE -D__BUILDING_CVC5DRIVER)
target_link_libraries(main-test PUBLIC cvc5 cvc5parser)
if(USE_CLN)
  target_link_libraries(main-test PUBLIC CLN)
endif()
if(USE_POLY)
  target_link_libraries(main-test PUBLIC Polyxx)
endif()

#-----------------------------------------------------------------------------#
# cvc5 binary configuration

add_executable(cvc5-bin driver_unified.cpp main.cpp $<TARGET_OBJECTS:main>)
target_compile_definitions(cvc5-bin PRIVATE -D__BUILDING_CVC5DRIVER -Dcvc5_obj_EXPORTS)
set_target_properties(cvc5-bin
  PROPERTIES
    OUTPUT_NAME cvc5
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
if(PROGRAM_PREFIX)
  install(PROGRAMS
    $<TARGET_FILE:cvc5-bin>
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    RENAME ${PROGRAM_PREFIX}cvc5)
else()
  install(TARGETS cvc5-bin
    DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

# In order to get a fully static executable we have to make sure that we also
# use the static system libraries.
#   https://cmake.org/cmake/help/v3.0/prop_tgt/LINK_SEARCH_START_STATIC.html
#   https://cmake.org/cmake/help/v3.0/prop_tgt/LINK_SEARCH_END_STATIC.html
if(NOT BUILD_SHARED_LIBS)
  if(STATIC_BINARY)
    set_target_properties(cvc5-bin PROPERTIES LINK_FLAGS -static)
    set_target_properties(cvc5-bin PROPERTIES LINK_SEARCH_START_STATIC ON)
    set_target_properties(cvc5-bin PROPERTIES LINK_SEARCH_END_STATIC ON)
  endif()
  set_target_properties(cvc5-bin PROPERTIES INSTALL_RPATH "")
endif()
target_link_libraries(cvc5-bin PUBLIC cvc5 cvc5parser)

if(USE_EDITLINE)
  target_link_libraries(cvc5-bin PUBLIC ${Editline_LIBRARIES})
  target_link_libraries(main-test PUBLIC ${Editline_LIBRARIES})
  target_include_directories(main PUBLIC ${Editline_INCLUDE_DIRS})
endif()

#-----------------------------------------------------------------------------#
# Generate language tokens header files.

add_custom_command(
  OUTPUT smt2_tokens.h
  COMMAND
    sh ${CMAKE_CURRENT_LIST_DIR}/gen-token-header.sh
        ${CMAKE_CURRENT_LIST_DIR}/../parser/smt2/smt2_cmd_parser.cpp
        smt2_tokens.h
  DEPENDS ../parser/smt2/smt2_cmd_parser.cpp
)

# Create target used as a dependency for libmain.
add_custom_target(gen-tokens
  DEPENDS
    smt2_tokens.h
)

=== src/parser/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Andrew Reynolds, Andres Noetzli, Gereon Kremer
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

#-----------------------------------------------------------------------------#
# libcvc5parser source files

set(libcvc5parserapi_src_files
  ../api/c/cvc5_parser.cpp
  ../api/cpp/cvc5_parser.cpp
)

set(libcvc5parser_src_files
  commands.cpp
  commands.h
  command_status.cpp
  command_status.h
  input.cpp
  input.h
  lexer.cpp
  lexer.h
  parser.cpp
  parser.h
  parse_op.cpp
  parse_op.h
  parser_state.cpp
  parser_state.h
  parser_utils.cpp
  parser_utils.h
  smt2/smt2_state.cpp
  smt2/smt2_state.h
  smt2/smt2_cmd_parser.cpp
  smt2/smt2_cmd_parser.h
  smt2/smt2_lexer.cpp
  smt2/smt2_lexer.h
  smt2/smt2_cmd_parser.cpp
  smt2/smt2_cmd_parser.h
  smt2/smt2_parser.cpp
  smt2/smt2_parser.h
  smt2/smt2_term_parser.cpp
  smt2/smt2_term_parser.h
  sym_manager.cpp
  sym_manager.h
  symbol_table.cpp
  symbol_table.h
  tokens.cpp
  tokens.h
)

#-----------------------------------------------------------------------------#
# libcvc5parser configuration

add_library(cvc5parser-objs OBJECT ${libcvc5parser_src_files})
set_target_properties(cvc5parser-objs PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(cvc5parser-objs PUBLIC -D__BUILDING_CVC5PARSERLIB -Dcvc5_obj_EXPORTS)

add_library(cvc5parserapi-objs OBJECT ${libcvc5parserapi_src_files})
set_target_properties(cvc5parserapi-objs PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(cvc5parserapi-objs PUBLIC -D__BUILDING_CVC5LIB -Dcvc5_obj_EXPORTS)

add_dependencies(cvc5parser-objs gen-expr gen-options)
add_dependencies(cvc5parserapi-objs cvc5parser-objs gen-expr)

add_library(cvc5parser
  $<TARGET_OBJECTS:cvc5parser-objs>
  $<TARGET_OBJECTS:cvc5parserapi-objs>
)
if(BUILD_SHARED_LIBS)
  set_target_properties(cvc5parser PROPERTIES SOVERSION ${CVC5_SOVERSION})
endif()

set_target_properties(cvc5parser PROPERTIES OUTPUT_NAME cvc5parser)
target_link_libraries(cvc5parser PRIVATE cvc5)

# On Windows, CMake's default install action places
# DLLs into the runtime path (by default "bin")
install(TARGETS cvc5parser EXPORT cvc5-targets)

=== src/rewriter/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Andrew Reynolds, Leni Aniva, Abdalrhman Mohamed
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

# Check if the pyparsing Python module is installed.
check_python_module("pyparsing")

libcvc5_add_sources(
  basic_rewrite_rcons.cpp
  basic_rewrite_rcons.h
  rewrite_db.cpp
  rewrite_db.h
  rewrite_db_proof_cons.cpp
  rewrite_db_proof_cons.h
  rewrite_db_term_process.cpp
  rewrite_db_term_process.h
  rewrite_proof_rule.cpp
  rewrite_proof_rule.h
  rewrite_proof_status.cpp
  rewrite_proof_status.h
  rewrites.h
)

set(mkrewrites_script ${CMAKE_CURRENT_LIST_DIR}/mkrewrites.py)

set(REWRITE_OUTPUT_FILES
  rewrites.cpp
)
foreach(rewrite_in IN LISTS REWRITES_FILES REWRITES_FILES_EXPERT)
  # NOTE: In CMake 3.20+, the `cmake_path` command can be used instead

  get_filename_component(rewrite_parent ${rewrite_in} DIRECTORY)
  get_filename_component(rewrite_name ${rewrite_in} NAME)
  get_filename_component(rewrite_dir ${rewrite_parent} NAME)
  list(APPEND REWRITE_OUTPUT_FILES "rewrites-${rewrite_dir}-${rewrite_name}.cpp")
endforeach()

libcvc5_add_sources(GENERATED
  ${REWRITE_OUTPUT_FILES}
)

list(APPEND REWRITE_OUTPUT_FILES
  ${CMAKE_BINARY_DIR}/src/api/cpp/cvc5_proof_rule.cpp
  ${CMAKE_BINARY_DIR}/include/cvc5/cvc5_proof_rule.h
)

# If the generated header differs from the source header, it should be copied to
# the source directory manually for compilation to succeed.
list(APPEND LIBCVC5_GEN_SRCS
  ${CMAKE_BINARY_DIR}/src/api/cpp/cvc5_proof_rule.cpp
)

set(LIBCVC5_GEN_SRCS ${LIBCVC5_GEN_SRCS} PARENT_SCOPE)

add_custom_command(
    OUTPUT
      ${REWRITE_OUTPUT_FILES}
    COMMAND
      ${Python_EXECUTABLE}
      ${mkrewrites_script}
      rewrite-db
      --src ${CMAKE_SOURCE_DIR}
      --bin ${CMAKE_BINARY_DIR}
      --rewrites_files ${REWRITES_FILES}
      --rewrites_files_expert ${REWRITES_FILES_EXPERT}
    DEPENDS
      ${mkrewrites_script}
      ${REWRITES_FILES}
      ${REWRITES_FILES_EXPERT}
      ${CMAKE_CURRENT_LIST_DIR}/theory_rewrites_template.cpp
      ${CMAKE_CURRENT_LIST_DIR}/rewrites_template.cpp
      ${CMAKE_SOURCE_DIR}/src/api/cpp/cvc5_proof_rule_template.cpp
      ${CMAKE_SOURCE_DIR}/include/cvc5/cvc5_proof_rule.h
    COMMENT
      "Generating rewrites.{h,cpp}"
)

add_custom_target(gen-rewrites
  DEPENDS
    ${REWRITE_OUTPUT_FILES}
)

=== debian/changelog ===
cvc5 (1.3.2-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 23 Jan 2026 14:45:16 +0000

cvc5 (1.3.2-1) unstable; urgency=medium

  [ Gábor Németh ]
  * Update to new upstream release 1.3.2 (Closes: #1074235 #1122401)
  * Bump CaDiCaL dependency to 2.1 as per upstream
  * Adapt patches to changed upstream build of Python bindings,
    remove applied
  * Use newer API calls in autopkgtest
  * Generate a man page
  * Fix typos found by lintian

 -- Scott Talbert <swt@techie.net>  Tue, 23 Dec 2025 19:41:53 -0500

=== debian/control ===
Source: cvc5
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Scott Talbert <swt@techie.net>
Section: math
Priority: optional
Build-Depends: chrpath,
               cmake,
               cxxtest,
               cython3,
               debhelper-compat (= 13),
               dh-sequence-python3,
               help2man,
               libboost-thread-dev,
               libcadical-dev (>= 2.1),
               libcln-dev,
               libcryptominisat5-dev,
               libfl-dev,
               libgmp-dev,
               libreadline-dev,
               libsymfpu-dev,
               pkgconf,
               python3,
               python3-dev,
               python3-pip,
               python3-pyparsing,
               python3-pytest,
               python3-skbuild,
Standards-Version: 4.6.2
Homepage: https://cvc5.github.io/
Vcs-Git: https://salsa.debian.org/science-team/cvc5.git
Vcs-Browser: https://salsa.debian.org/science-team/cvc5
Rules-Requires-Root: no

Package: cvc5
Architecture: any
Depends: libcvc5-1 (= ${binary:Version}),
         libcvc5parser1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: automated theorem prover for SMT problems
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains binaries needed to use cvc5 as a stand-alone
 tool.

Package: libcvc5-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libcvc5-1 (= ${binary:Version}),
         libcvc5parser1 (= ${binary:Version}),
         libgmp-dev,
         ${misc:Depends},
         ${shlibs:Depends},
Description: automated theorem prover for SMT problems (development files)
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains development files for cvc5. Install it if you
 want to develop applications that use cvc5's API.

Package: libcvc5-1
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: automated theorem prover for SMT problems (runtime)
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains cvc5's runtime shared libraries.

Package: libcvc5parser1
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: automated theorem prover for SMT problems (parser runtime)
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains runtime shared libraries for cvc5's parser.

Package: python3-cvc5
Architecture: any
Section: python
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Description: automated theorem prover for SMT problems (Python bindings)
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains the Python bindings for cvc5's parser.
